":";exec java -cp $HOME/roBin/src:$HOME/roBin/lib/* clojure.main $0 $*; 

(ns rlm.play-all
  (:gen-class
   :name rlm.playAll
   :main true)
  (:use [clojure.contrib
	 [shell-out :only [sh]]
	 [accumulators :only [combine]]
	 [command-line :only [with-command-line]]
	 [duck-streams :only [file-str]]]
	[rlm
	 [shell-write :only [sw]]
	 [shell-inspect :only [command-line?]]]))


(def allowed-types
     [#".*\.mp3$"
      #".*\.m4a$"
      #".*\.wav$"])

(def music
     ["/home/r/Desktop/first-archive/sounds"])

(defn music-files []
     (shuffle
      (doall (filter 
	      (fn [b] (some (fn [a] (re-matches a (.getPath b))) allowed-types))       
	      (apply combine
		     (map #(apply vector %)
			  (map file-seq 
			       (map file-str music))))))))

(defn enqueue
     [#^java.io.File file]
     (sh "totem" "--enqueue" (.getPath file)))

(defn play-all-music
  "runs commands which enque music to totem from a separate thread.
   just run this command and don't worry about it anymore."
  []
  (.start (Thread. (partial sh "totem")))
  (.start (Thread. (fn [] (dorun (map enqueue (music-files)))))))

(defn -main [& args]
  (with-command-line args 
    "Play every Music File ever :)"
    []
    (println "playing all music from" music)
    (play-all-music)
    ))


(if (command-line?)
  (apply -main *command-line-args*))
